#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK80x0x80TN4x1x12_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=80, NB=0, KB=80, 
 * lda=80, ldb=80, ldc=0, mu=4, nu=1, ku=12, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const float *stM = A + 6400;
   const float *stN = B + (((Nb) << 6)+((Nb) << 4));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*1)/(80*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 12
   const int incAm = 240, incAn = -6400;
   #define incBk 12
   const int incBm = -80, incBn = 80;
   const int incAk0 = ((incAk) / 12), incBk0 = ((incBk) / 12);
   #define incCm 8
   const int incCn = (((ldc) << 1)) - 160;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0;
   register float m0, m1, m2, m3, m4, m5, m6, m7, m8, m9, m10, m11;
   register float rC0_0, rC1_0, rC2_0, rC3_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[2];
         rC1_0 *= rA0;
         rC2_0 = pC0[4];
         rC2_0 *= rA0;
         rC3_0 = pC0[6];
         rC3_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[80];
         rA2 = pA0[160];
         rA3 = pA0[240];
         m0 = rA0 * rB0;
         m1 = rA1 * rB0;
         m2 = rA2 * rB0;
         m3 = rA3 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[81];
         rA2 = pA0[161];
         rA3 = pA0[241];
         m4 = rA0 * rB0;
         m5 = rA1 * rB0;
         m6 = rA2 * rB0;
         m7 = rA3 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA0[82];
         rA2 = pA0[162];
         rA3 = pA0[242];
         m8 = rA0 * rB0;
         m9 = rA1 * rB0;
         m10 = rA2 * rB0;
         m11 = rA3 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rA1 = pA0[83];
         rA2 = pA0[163];
         rA3 = pA0[243];

         pA0 += (((incAk0) << 1)+incAk0);
         pB0 += (((incBk0) << 1)+incBk0);
         for (k=72; k; k -= 12) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC2_0 += m2;
            m2 = rA2 * rB0;
            rC3_0 += m3;
            m3 = rA3 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[81];
            rA2 = pA0[161];
            rA3 = pA0[241];
            rC0_0 += m4;
            m4 = rA0 * rB0;
            rC1_0 += m5;
            m5 = rA1 * rB0;
            rC2_0 += m6;
            m6 = rA2 * rB0;
            rC3_0 += m7;
            m7 = rA3 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[82];
            rA2 = pA0[162];
            rA3 = pA0[242];
            rC0_0 += m8;
            m8 = rA0 * rB0;
            rC1_0 += m9;
            m9 = rA1 * rB0;
            rC2_0 += m10;
            m10 = rA2 * rB0;
            rC3_0 += m11;
            m11 = rA3 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[83];
            rA2 = pA0[163];
            rA3 = pA0[243];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC2_0 += m2;
            m2 = rA2 * rB0;
            rC3_0 += m3;
            m3 = rA3 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[84];
            rA2 = pA0[164];
            rA3 = pA0[244];
            rC0_0 += m4;
            m4 = rA0 * rB0;
            rC1_0 += m5;
            m5 = rA1 * rB0;
            rC2_0 += m6;
            m6 = rA2 * rB0;
            rC3_0 += m7;
            m7 = rA3 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[85];
            rA2 = pA0[165];
            rA3 = pA0[245];
            rC0_0 += m8;
            m8 = rA0 * rB0;
            rC1_0 += m9;
            m9 = rA1 * rB0;
            rC2_0 += m10;
            m10 = rA2 * rB0;
            rC3_0 += m11;
            m11 = rA3 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[86];
            rA2 = pA0[166];
            rA3 = pA0[246];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC2_0 += m2;
            m2 = rA2 * rB0;
            rC3_0 += m3;
            m3 = rA3 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[87];
            rA2 = pA0[167];
            rA3 = pA0[247];
            rC0_0 += m4;
            m4 = rA0 * rB0;
            rC1_0 += m5;
            m5 = rA1 * rB0;
            rC2_0 += m6;
            m6 = rA2 * rB0;
            rC3_0 += m7;
            m7 = rA3 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rA1 = pA0[88];
            rA2 = pA0[168];
            rA3 = pA0[248];
            rC0_0 += m8;
            m8 = rA0 * rB0;
            rC1_0 += m9;
            m9 = rA1 * rB0;
            rC2_0 += m10;
            m10 = rA2 * rB0;
            rC3_0 += m11;
            m11 = rA3 * rB0;
            rA0 = pA0[9];
            rB0 = pB0[9];
            rA1 = pA0[89];
            rA2 = pA0[169];
            rA3 = pA0[249];
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC2_0 += m2;
            m2 = rA2 * rB0;
            rC3_0 += m3;
            m3 = rA3 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rA1 = pA0[90];
            rA2 = pA0[170];
            rA3 = pA0[250];
            rC0_0 += m4;
            m4 = rA0 * rB0;
            rC1_0 += m5;
            m5 = rA1 * rB0;
            rC2_0 += m6;
            m6 = rA2 * rB0;
            rC3_0 += m7;
            m7 = rA3 * rB0;
            rA0 = pA0[11];
            rB0 = pB0[11];
            rA1 = pA0[91];
            rA2 = pA0[171];
            rA3 = pA0[251];
            rC0_0 += m8;
            m8 = rA0 * rB0;
            rC1_0 += m9;
            m9 = rA1 * rB0;
            rC2_0 += m10;
            m10 = rA2 * rB0;
            rC3_0 += m11;
            m11 = rA3 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rA1 = pA0[92];
            rA2 = pA0[172];
            rA3 = pA0[252];
            pA0 += incAk;
            pB0 += incBk;
         } /* end K-loop */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[81];
         rA2 = pA0[161];
         rA3 = pA0[241];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA0[82];
         rA2 = pA0[162];
         rA3 = pA0[242];
         rC0_0 += m8;
         m8 = rA0 * rB0;
         rC1_0 += m9;
         m9 = rA1 * rB0;
         rC2_0 += m10;
         m10 = rA2 * rB0;
         rC3_0 += m11;
         m11 = rA3 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rA1 = pA0[83];
         rA2 = pA0[163];
         rA3 = pA0[243];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rA1 = pA0[84];
         rA2 = pA0[164];
         rA3 = pA0[244];
         pA0 += (((incAk0) << 2));
         pB0 += (((incBk0) << 2));
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         rC0_0 += m8;
         rC1_0 += m9;
         rC2_0 += m10;
         rC3_0 += m11;
         rC0_0 += m0;
         rC1_0 += m1;
         rC2_0 += m2;
         rC3_0 += m3;
         rC0_0 += m4;
         rC1_0 += m5;
         rC2_0 += m6;
         rC3_0 += m7;
         pA0 += incAk0;
         pB0 += incBk0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK80x0x80TN80x80x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=80, NB=0, KB=80, 
 * lda=80, ldb=80, ldc=0, mu=4, nu=6, ku=12, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Nb = (N/6)*6;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 6400;
   const float *stN = B + (((Nb) << 6)+((Nb) << 4));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*6)/(80*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 12
   const int incAm = 240, incAn = -6400;
   #define incBk 12
   const int incBm = -80, incBn = 480;
   const int incAk0 = ((incAk) / 12), incBk0 = ((incBk) / 12);
   #define incCm 8
   const int incCn = (((ldc) << 3)+((ldc) << 2)) - 160;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0, rB1, rB2, rB3, rB4, rB5;
   register float m0, m1, m2, m3, m4, m5, m6, m7, m8, m9, m10, m11;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2, rC0_3, rC1_3, rC2_3, rC3_3, rC0_4, rC1_4, rC2_4, rC3_4, rC0_5, rC1_5, rC2_5, rC3_5;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[2];
            rC1_0 *= rA0;
            rC2_0 = pC0[4];
            rC2_0 *= rA0;
            rC3_0 = pC0[6];
            rC3_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC1_1 = pC1[2];
            rC1_1 *= rA0;
            rC2_1 = pC1[4];
            rC2_1 *= rA0;
            rC3_1 = pC1[6];
            rC3_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC1_2 = pC2[2];
            rC1_2 *= rA0;
            rC2_2 = pC2[4];
            rC2_2 *= rA0;
            rC3_2 = pC2[6];
            rC3_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            rC1_3 = pC3[2];
            rC1_3 *= rA0;
            rC2_3 = pC3[4];
            rC2_3 *= rA0;
            rC3_3 = pC3[6];
            rC3_3 *= rA0;
            rC0_4 = *pC4;
            rC0_4 *= rA0;
            rC1_4 = pC4[2];
            rC1_4 *= rA0;
            rC2_4 = pC4[4];
            rC2_4 *= rA0;
            rC3_4 = pC4[6];
            rC3_4 *= rA0;
            rC0_5 = *pC5;
            rC0_5 *= rA0;
            rC1_5 = pC5[2];
            rC1_5 *= rA0;
            rC2_5 = pC5[4];
            rC2_5 *= rA0;
            rC3_5 = pC5[6];
            rC3_5 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[80];
            rA2 = pA0[160];
            rA3 = pA0[240];
            rB1 = pB0[80];
            rB2 = pB0[160];
            m0 = rA0 * rB0;
            rB3 = pB0[240];
            m1 = rA1 * rB0;
            rB4 = pB0[320];
            m2 = rA2 * rB0;
            rB5 = pB0[400];
            m3 = rA3 * rB0;
            m4 = rA0 * rB1;
            m5 = rA1 * rB1;
            m6 = rA2 * rB1;
            m7 = rA3 * rB1;
            m8 = rA0 * rB2;
            m9 = rA1 * rB2;
            m10 = rA2 * rB2;
            m11 = rA3 * rB2;

            for (k=72; k; k -= 12) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC2_0 += m2;
               m2 = rA2 * rB3;
               rC3_0 += m3;
               m3 = rA3 * rB3;
               rC0_1 += m4;
               m4 = rA0 * rB4;
               rC1_1 += m5;
               m5 = rA1 * rB4;
               rC2_1 += m6;
               m6 = rA2 * rB4;
               rC3_1 += m7;
               m7 = rA3 * rB4;
               rC0_2 += m8;
               m8 = rA0 * rB5;
               rC1_2 += m9;
               m9 = rA1 * rB5;
               rC2_2 += m10;
               m10 = rA2 * rB5;
               rC3_2 += m11;
               m11 = rA3 * rB5;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[81];
               rA2 = pA0[161];
               rA3 = pA0[241];
               rB1 = pB0[81];
               rB2 = pB0[161];
               rB3 = pB0[241];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB4 = pB0[321];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB5 = pB0[401];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_5 += m8;
               m8 = rA0 * rB2;
               rC1_5 += m9;
               m9 = rA1 * rB2;
               rC2_5 += m10;
               m10 = rA2 * rB2;
               rC3_5 += m11;
               m11 = rA3 * rB2;
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC2_0 += m2;
               m2 = rA2 * rB3;
               rC3_0 += m3;
               m3 = rA3 * rB3;
               rC0_1 += m4;
               m4 = rA0 * rB4;
               rC1_1 += m5;
               m5 = rA1 * rB4;
               rC2_1 += m6;
               m6 = rA2 * rB4;
               rC3_1 += m7;
               m7 = rA3 * rB4;
               rC0_2 += m8;
               m8 = rA0 * rB5;
               rC1_2 += m9;
               m9 = rA1 * rB5;
               rC2_2 += m10;
               m10 = rA2 * rB5;
               rC3_2 += m11;
               m11 = rA3 * rB5;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[82];
               rA2 = pA0[162];
               rA3 = pA0[242];
               rB1 = pB0[82];
               rB2 = pB0[162];
               rB3 = pB0[242];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB4 = pB0[322];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB5 = pB0[402];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_5 += m8;
               m8 = rA0 * rB2;
               rC1_5 += m9;
               m9 = rA1 * rB2;
               rC2_5 += m10;
               m10 = rA2 * rB2;
               rC3_5 += m11;
               m11 = rA3 * rB2;
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC2_0 += m2;
               m2 = rA2 * rB3;
               rC3_0 += m3;
               m3 = rA3 * rB3;
               rC0_1 += m4;
               m4 = rA0 * rB4;
               rC1_1 += m5;
               m5 = rA1 * rB4;
               rC2_1 += m6;
               m6 = rA2 * rB4;
               rC3_1 += m7;
               m7 = rA3 * rB4;
               rC0_2 += m8;
               m8 = rA0 * rB5;
               rC1_2 += m9;
               m9 = rA1 * rB5;
               rC2_2 += m10;
               m10 = rA2 * rB5;
               rC3_2 += m11;
               m11 = rA3 * rB5;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[83];
               rA2 = pA0[163];
               rA3 = pA0[243];
               rB1 = pB0[83];
               rB2 = pB0[163];
               rB3 = pB0[243];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB4 = pB0[323];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB5 = pB0[403];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_5 += m8;
               m8 = rA0 * rB2;
               rC1_5 += m9;
               m9 = rA1 * rB2;
               rC2_5 += m10;
               m10 = rA2 * rB2;
               rC3_5 += m11;
               m11 = rA3 * rB2;
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC2_0 += m2;
               m2 = rA2 * rB3;
               rC3_0 += m3;
               m3 = rA3 * rB3;
               rC0_1 += m4;
               m4 = rA0 * rB4;
               rC1_1 += m5;
               m5 = rA1 * rB4;
               rC2_1 += m6;
               m6 = rA2 * rB4;
               rC3_1 += m7;
               m7 = rA3 * rB4;
               rC0_2 += m8;
               m8 = rA0 * rB5;
               rC1_2 += m9;
               m9 = rA1 * rB5;
               rC2_2 += m10;
               m10 = rA2 * rB5;
               rC3_2 += m11;
               m11 = rA3 * rB5;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA0[84];
               rA2 = pA0[164];
               rA3 = pA0[244];
               rB1 = pB0[84];
               rB2 = pB0[164];
               rB3 = pB0[244];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB4 = pB0[324];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB5 = pB0[404];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_5 += m8;
               m8 = rA0 * rB2;
               rC1_5 += m9;
               m9 = rA1 * rB2;
               rC2_5 += m10;
               m10 = rA2 * rB2;
               rC3_5 += m11;
               m11 = rA3 * rB2;
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC2_0 += m2;
               m2 = rA2 * rB3;
               rC3_0 += m3;
               m3 = rA3 * rB3;
               rC0_1 += m4;
               m4 = rA0 * rB4;
               rC1_1 += m5;
               m5 = rA1 * rB4;
               rC2_1 += m6;
               m6 = rA2 * rB4;
               rC3_1 += m7;
               m7 = rA3 * rB4;
               rC0_2 += m8;
               m8 = rA0 * rB5;
               rC1_2 += m9;
               m9 = rA1 * rB5;
               rC2_2 += m10;
               m10 = rA2 * rB5;
               rC3_2 += m11;
               m11 = rA3 * rB5;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA0[85];
               rA2 = pA0[165];
               rA3 = pA0[245];
               rB1 = pB0[85];
               rB2 = pB0[165];
               rB3 = pB0[245];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB4 = pB0[325];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB5 = pB0[405];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_5 += m8;
               m8 = rA0 * rB2;
               rC1_5 += m9;
               m9 = rA1 * rB2;
               rC2_5 += m10;
               m10 = rA2 * rB2;
               rC3_5 += m11;
               m11 = rA3 * rB2;
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC2_0 += m2;
               m2 = rA2 * rB3;
               rC3_0 += m3;
               m3 = rA3 * rB3;
               rC0_1 += m4;
               m4 = rA0 * rB4;
               rC1_1 += m5;
               m5 = rA1 * rB4;
               rC2_1 += m6;
               m6 = rA2 * rB4;
               rC3_1 += m7;
               m7 = rA3 * rB4;
               rC0_2 += m8;
               m8 = rA0 * rB5;
               rC1_2 += m9;
               m9 = rA1 * rB5;
               rC2_2 += m10;
               m10 = rA2 * rB5;
               rC3_2 += m11;
               m11 = rA3 * rB5;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA0[86];
               rA2 = pA0[166];
               rA3 = pA0[246];
               rB1 = pB0[86];
               rB2 = pB0[166];
               rB3 = pB0[246];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB4 = pB0[326];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB5 = pB0[406];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_5 += m8;
               m8 = rA0 * rB2;
               rC1_5 += m9;
               m9 = rA1 * rB2;
               rC2_5 += m10;
               m10 = rA2 * rB2;
               rC3_5 += m11;
               m11 = rA3 * rB2;
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC2_0 += m2;
               m2 = rA2 * rB3;
               rC3_0 += m3;
               m3 = rA3 * rB3;
               rC0_1 += m4;
               m4 = rA0 * rB4;
               rC1_1 += m5;
               m5 = rA1 * rB4;
               rC2_1 += m6;
               m6 = rA2 * rB4;
               rC3_1 += m7;
               m7 = rA3 * rB4;
               rC0_2 += m8;
               m8 = rA0 * rB5;
               rC1_2 += m9;
               m9 = rA1 * rB5;
               rC2_2 += m10;
               m10 = rA2 * rB5;
               rC3_2 += m11;
               m11 = rA3 * rB5;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA0[87];
               rA2 = pA0[167];
               rA3 = pA0[247];
               rB1 = pB0[87];
               rB2 = pB0[167];
               rB3 = pB0[247];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB4 = pB0[327];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB5 = pB0[407];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_5 += m8;
               m8 = rA0 * rB2;
               rC1_5 += m9;
               m9 = rA1 * rB2;
               rC2_5 += m10;
               m10 = rA2 * rB2;
               rC3_5 += m11;
               m11 = rA3 * rB2;
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC2_0 += m2;
               m2 = rA2 * rB3;
               rC3_0 += m3;
               m3 = rA3 * rB3;
               rC0_1 += m4;
               m4 = rA0 * rB4;
               rC1_1 += m5;
               m5 = rA1 * rB4;
               rC2_1 += m6;
               m6 = rA2 * rB4;
               rC3_1 += m7;
               m7 = rA3 * rB4;
               rC0_2 += m8;
               m8 = rA0 * rB5;
               rC1_2 += m9;
               m9 = rA1 * rB5;
               rC2_2 += m10;
               m10 = rA2 * rB5;
               rC3_2 += m11;
               m11 = rA3 * rB5;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA0[88];
               rA2 = pA0[168];
               rA3 = pA0[248];
               rB1 = pB0[88];
               rB2 = pB0[168];
               rB3 = pB0[248];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB4 = pB0[328];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB5 = pB0[408];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_5 += m8;
               m8 = rA0 * rB2;
               rC1_5 += m9;
               m9 = rA1 * rB2;
               rC2_5 += m10;
               m10 = rA2 * rB2;
               rC3_5 += m11;
               m11 = rA3 * rB2;
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC2_0 += m2;
               m2 = rA2 * rB3;
               rC3_0 += m3;
               m3 = rA3 * rB3;
               rC0_1 += m4;
               m4 = rA0 * rB4;
               rC1_1 += m5;
               m5 = rA1 * rB4;
               rC2_1 += m6;
               m6 = rA2 * rB4;
               rC3_1 += m7;
               m7 = rA3 * rB4;
               rC0_2 += m8;
               m8 = rA0 * rB5;
               rC1_2 += m9;
               m9 = rA1 * rB5;
               rC2_2 += m10;
               m10 = rA2 * rB5;
               rC3_2 += m11;
               m11 = rA3 * rB5;
               rA0 = pA0[9];
               rB0 = pB0[9];
               rA1 = pA0[89];
               rA2 = pA0[169];
               rA3 = pA0[249];
               rB1 = pB0[89];
               rB2 = pB0[169];
               rB3 = pB0[249];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB4 = pB0[329];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB5 = pB0[409];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_5 += m8;
               m8 = rA0 * rB2;
               rC1_5 += m9;
               m9 = rA1 * rB2;
               rC2_5 += m10;
               m10 = rA2 * rB2;
               rC3_5 += m11;
               m11 = rA3 * rB2;
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC2_0 += m2;
               m2 = rA2 * rB3;
               rC3_0 += m3;
               m3 = rA3 * rB3;
               rC0_1 += m4;
               m4 = rA0 * rB4;
               rC1_1 += m5;
               m5 = rA1 * rB4;
               rC2_1 += m6;
               m6 = rA2 * rB4;
               rC3_1 += m7;
               m7 = rA3 * rB4;
               rC0_2 += m8;
               m8 = rA0 * rB5;
               rC1_2 += m9;
               m9 = rA1 * rB5;
               rC2_2 += m10;
               m10 = rA2 * rB5;
               rC3_2 += m11;
               m11 = rA3 * rB5;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA0[90];
               rA2 = pA0[170];
               rA3 = pA0[250];
               rB1 = pB0[90];
               rB2 = pB0[170];
               rB3 = pB0[250];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB4 = pB0[330];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB5 = pB0[410];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_5 += m8;
               m8 = rA0 * rB2;
               rC1_5 += m9;
               m9 = rA1 * rB2;
               rC2_5 += m10;
               m10 = rA2 * rB2;
               rC3_5 += m11;
               m11 = rA3 * rB2;
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC2_0 += m2;
               m2 = rA2 * rB3;
               rC3_0 += m3;
               m3 = rA3 * rB3;
               rC0_1 += m4;
               m4 = rA0 * rB4;
               rC1_1 += m5;
               m5 = rA1 * rB4;
               rC2_1 += m6;
               m6 = rA2 * rB4;
               rC3_1 += m7;
               m7 = rA3 * rB4;
               rC0_2 += m8;
               m8 = rA0 * rB5;
               rC1_2 += m9;
               m9 = rA1 * rB5;
               rC2_2 += m10;
               m10 = rA2 * rB5;
               rC3_2 += m11;
               m11 = rA3 * rB5;
               rA0 = pA0[11];
               rB0 = pB0[11];
               rA1 = pA0[91];
               rA2 = pA0[171];
               rA3 = pA0[251];
               rB1 = pB0[91];
               rB2 = pB0[171];
               rB3 = pB0[251];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB4 = pB0[331];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB5 = pB0[411];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_5 += m8;
               m8 = rA0 * rB2;
               rC1_5 += m9;
               m9 = rA1 * rB2;
               rC2_5 += m10;
               m10 = rA2 * rB2;
               rC3_5 += m11;
               m11 = rA3 * rB2;
               rC0_0 += m0;
               m0 = rA0 * rB3;
               rC1_0 += m1;
               m1 = rA1 * rB3;
               rC2_0 += m2;
               m2 = rA2 * rB3;
               rC3_0 += m3;
               m3 = rA3 * rB3;
               rC0_1 += m4;
               m4 = rA0 * rB4;
               rC1_1 += m5;
               m5 = rA1 * rB4;
               rC2_1 += m6;
               m6 = rA2 * rB4;
               rC3_1 += m7;
               m7 = rA3 * rB4;
               rC0_2 += m8;
               m8 = rA0 * rB5;
               rC1_2 += m9;
               m9 = rA1 * rB5;
               rC2_2 += m10;
               m10 = rA2 * rB5;
               rC3_2 += m11;
               m11 = rA3 * rB5;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA0[92];
               rA2 = pA0[172];
               rA3 = pA0[252];
               rB1 = pB0[92];
               rB2 = pB0[172];
               rB3 = pB0[252];
               rC0_3 += m0;
               m0 = rA0 * rB0;
               rB4 = pB0[332];
               rC1_3 += m1;
               m1 = rA1 * rB0;
               rB5 = pB0[412];
               rC2_3 += m2;
               m2 = rA2 * rB0;
               rC3_3 += m3;
               m3 = rA3 * rB0;
               rC0_4 += m4;
               m4 = rA0 * rB1;
               rC1_4 += m5;
               m5 = rA1 * rB1;
               rC2_4 += m6;
               m6 = rA2 * rB1;
               rC3_4 += m7;
               m7 = rA3 * rB1;
               rC0_5 += m8;
               m8 = rA0 * rB2;
               rC1_5 += m9;
               m9 = rA1 * rB2;
               rC2_5 += m10;
               m10 = rA2 * rB2;
               rC3_5 += m11;
               m11 = rA3 * rB2;
               pA0 += incAk;
               pB0 += incBk;
            } /* end K-loop */
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rC2_0 += m2;
            m2 = rA2 * rB3;
            rC3_0 += m3;
            m3 = rA3 * rB3;
            rC0_1 += m4;
            m4 = rA0 * rB4;
            rC1_1 += m5;
            m5 = rA1 * rB4;
            rC2_1 += m6;
            m6 = rA2 * rB4;
            rC3_1 += m7;
            m7 = rA3 * rB4;
            rC0_2 += m8;
            m8 = rA0 * rB5;
            rC1_2 += m9;
            m9 = rA1 * rB5;
            rC2_2 += m10;
            m10 = rA2 * rB5;
            rC3_2 += m11;
            m11 = rA3 * rB5;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[81];
            rA2 = pA0[161];
            rA3 = pA0[241];
            rB1 = pB0[81];
            rB2 = pB0[161];
            rB3 = pB0[241];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[321];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB5 = pB0[401];
            rC2_3 += m2;
            m2 = rA2 * rB0;
            rC3_3 += m3;
            m3 = rA3 * rB0;
            rC0_4 += m4;
            m4 = rA0 * rB1;
            rC1_4 += m5;
            m5 = rA1 * rB1;
            rC2_4 += m6;
            m6 = rA2 * rB1;
            rC3_4 += m7;
            m7 = rA3 * rB1;
            rC0_5 += m8;
            m8 = rA0 * rB2;
            rC1_5 += m9;
            m9 = rA1 * rB2;
            rC2_5 += m10;
            m10 = rA2 * rB2;
            rC3_5 += m11;
            m11 = rA3 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rC2_0 += m2;
            m2 = rA2 * rB3;
            rC3_0 += m3;
            m3 = rA3 * rB3;
            rC0_1 += m4;
            m4 = rA0 * rB4;
            rC1_1 += m5;
            m5 = rA1 * rB4;
            rC2_1 += m6;
            m6 = rA2 * rB4;
            rC3_1 += m7;
            m7 = rA3 * rB4;
            rC0_2 += m8;
            m8 = rA0 * rB5;
            rC1_2 += m9;
            m9 = rA1 * rB5;
            rC2_2 += m10;
            m10 = rA2 * rB5;
            rC3_2 += m11;
            m11 = rA3 * rB5;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[82];
            rA2 = pA0[162];
            rA3 = pA0[242];
            rB1 = pB0[82];
            rB2 = pB0[162];
            rB3 = pB0[242];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[322];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB5 = pB0[402];
            rC2_3 += m2;
            m2 = rA2 * rB0;
            rC3_3 += m3;
            m3 = rA3 * rB0;
            rC0_4 += m4;
            m4 = rA0 * rB1;
            rC1_4 += m5;
            m5 = rA1 * rB1;
            rC2_4 += m6;
            m6 = rA2 * rB1;
            rC3_4 += m7;
            m7 = rA3 * rB1;
            rC0_5 += m8;
            m8 = rA0 * rB2;
            rC1_5 += m9;
            m9 = rA1 * rB2;
            rC2_5 += m10;
            m10 = rA2 * rB2;
            rC3_5 += m11;
            m11 = rA3 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rC2_0 += m2;
            m2 = rA2 * rB3;
            rC3_0 += m3;
            m3 = rA3 * rB3;
            rC0_1 += m4;
            m4 = rA0 * rB4;
            rC1_1 += m5;
            m5 = rA1 * rB4;
            rC2_1 += m6;
            m6 = rA2 * rB4;
            rC3_1 += m7;
            m7 = rA3 * rB4;
            rC0_2 += m8;
            m8 = rA0 * rB5;
            rC1_2 += m9;
            m9 = rA1 * rB5;
            rC2_2 += m10;
            m10 = rA2 * rB5;
            rC3_2 += m11;
            m11 = rA3 * rB5;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[83];
            rA2 = pA0[163];
            rA3 = pA0[243];
            rB1 = pB0[83];
            rB2 = pB0[163];
            rB3 = pB0[243];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[323];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB5 = pB0[403];
            rC2_3 += m2;
            m2 = rA2 * rB0;
            rC3_3 += m3;
            m3 = rA3 * rB0;
            rC0_4 += m4;
            m4 = rA0 * rB1;
            rC1_4 += m5;
            m5 = rA1 * rB1;
            rC2_4 += m6;
            m6 = rA2 * rB1;
            rC3_4 += m7;
            m7 = rA3 * rB1;
            rC0_5 += m8;
            m8 = rA0 * rB2;
            rC1_5 += m9;
            m9 = rA1 * rB2;
            rC2_5 += m10;
            m10 = rA2 * rB2;
            rC3_5 += m11;
            m11 = rA3 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rC2_0 += m2;
            m2 = rA2 * rB3;
            rC3_0 += m3;
            m3 = rA3 * rB3;
            rC0_1 += m4;
            m4 = rA0 * rB4;
            rC1_1 += m5;
            m5 = rA1 * rB4;
            rC2_1 += m6;
            m6 = rA2 * rB4;
            rC3_1 += m7;
            m7 = rA3 * rB4;
            rC0_2 += m8;
            m8 = rA0 * rB5;
            rC1_2 += m9;
            m9 = rA1 * rB5;
            rC2_2 += m10;
            m10 = rA2 * rB5;
            rC3_2 += m11;
            m11 = rA3 * rB5;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[84];
            rA2 = pA0[164];
            rA3 = pA0[244];
            rB1 = pB0[84];
            rB2 = pB0[164];
            rB3 = pB0[244];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[324];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB5 = pB0[404];
            rC2_3 += m2;
            m2 = rA2 * rB0;
            rC3_3 += m3;
            m3 = rA3 * rB0;
            rC0_4 += m4;
            m4 = rA0 * rB1;
            rC1_4 += m5;
            m5 = rA1 * rB1;
            rC2_4 += m6;
            m6 = rA2 * rB1;
            rC3_4 += m7;
            m7 = rA3 * rB1;
            rC0_5 += m8;
            m8 = rA0 * rB2;
            rC1_5 += m9;
            m9 = rA1 * rB2;
            rC2_5 += m10;
            m10 = rA2 * rB2;
            rC3_5 += m11;
            m11 = rA3 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rC2_0 += m2;
            m2 = rA2 * rB3;
            rC3_0 += m3;
            m3 = rA3 * rB3;
            rC0_1 += m4;
            m4 = rA0 * rB4;
            rC1_1 += m5;
            m5 = rA1 * rB4;
            rC2_1 += m6;
            m6 = rA2 * rB4;
            rC3_1 += m7;
            m7 = rA3 * rB4;
            rC0_2 += m8;
            m8 = rA0 * rB5;
            rC1_2 += m9;
            m9 = rA1 * rB5;
            rC2_2 += m10;
            m10 = rA2 * rB5;
            rC3_2 += m11;
            m11 = rA3 * rB5;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[85];
            rA2 = pA0[165];
            rA3 = pA0[245];
            rB1 = pB0[85];
            rB2 = pB0[165];
            rB3 = pB0[245];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[325];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB5 = pB0[405];
            rC2_3 += m2;
            m2 = rA2 * rB0;
            rC3_3 += m3;
            m3 = rA3 * rB0;
            rC0_4 += m4;
            m4 = rA0 * rB1;
            rC1_4 += m5;
            m5 = rA1 * rB1;
            rC2_4 += m6;
            m6 = rA2 * rB1;
            rC3_4 += m7;
            m7 = rA3 * rB1;
            rC0_5 += m8;
            m8 = rA0 * rB2;
            rC1_5 += m9;
            m9 = rA1 * rB2;
            rC2_5 += m10;
            m10 = rA2 * rB2;
            rC3_5 += m11;
            m11 = rA3 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rC2_0 += m2;
            m2 = rA2 * rB3;
            rC3_0 += m3;
            m3 = rA3 * rB3;
            rC0_1 += m4;
            m4 = rA0 * rB4;
            rC1_1 += m5;
            m5 = rA1 * rB4;
            rC2_1 += m6;
            m6 = rA2 * rB4;
            rC3_1 += m7;
            m7 = rA3 * rB4;
            rC0_2 += m8;
            m8 = rA0 * rB5;
            rC1_2 += m9;
            m9 = rA1 * rB5;
            rC2_2 += m10;
            m10 = rA2 * rB5;
            rC3_2 += m11;
            m11 = rA3 * rB5;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[86];
            rA2 = pA0[166];
            rA3 = pA0[246];
            rB1 = pB0[86];
            rB2 = pB0[166];
            rB3 = pB0[246];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[326];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB5 = pB0[406];
            rC2_3 += m2;
            m2 = rA2 * rB0;
            rC3_3 += m3;
            m3 = rA3 * rB0;
            rC0_4 += m4;
            m4 = rA0 * rB1;
            rC1_4 += m5;
            m5 = rA1 * rB1;
            rC2_4 += m6;
            m6 = rA2 * rB1;
            rC3_4 += m7;
            m7 = rA3 * rB1;
            rC0_5 += m8;
            m8 = rA0 * rB2;
            rC1_5 += m9;
            m9 = rA1 * rB2;
            rC2_5 += m10;
            m10 = rA2 * rB2;
            rC3_5 += m11;
            m11 = rA3 * rB2;
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rC2_0 += m2;
            m2 = rA2 * rB3;
            rC3_0 += m3;
            m3 = rA3 * rB3;
            rC0_1 += m4;
            m4 = rA0 * rB4;
            rC1_1 += m5;
            m5 = rA1 * rB4;
            rC2_1 += m6;
            m6 = rA2 * rB4;
            rC3_1 += m7;
            m7 = rA3 * rB4;
            rC0_2 += m8;
            m8 = rA0 * rB5;
            rC1_2 += m9;
            m9 = rA1 * rB5;
            rC2_2 += m10;
            m10 = rA2 * rB5;
            rC3_2 += m11;
            m11 = rA3 * rB5;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[87];
            rA2 = pA0[167];
            rA3 = pA0[247];
            rB1 = pB0[87];
            rB2 = pB0[167];
            rB3 = pB0[247];
            rC0_3 += m0;
            m0 = rA0 * rB0;
            rB4 = pB0[327];
            rC1_3 += m1;
            m1 = rA1 * rB0;
            rB5 = pB0[407];
            rC2_3 += m2;
            m2 = rA2 * rB0;
            rC3_3 += m3;
            m3 = rA3 * rB0;
            rC0_4 += m4;
            m4 = rA0 * rB1;
            rC1_4 += m5;
            m5 = rA1 * rB1;
            rC2_4 += m6;
            m6 = rA2 * rB1;
            rC3_4 += m7;
            m7 = rA3 * rB1;
            rC0_5 += m8;
            m8 = rA0 * rB2;
            rC1_5 += m9;
            m9 = rA1 * rB2;
            rC2_5 += m10;
            m10 = rA2 * rB2;
            rC3_5 += m11;
            m11 = rA3 * rB2;
            pA0 += (7*(incAk0));
            pB0 += (7*(incBk0));
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB3;
            rC1_0 += m1;
            m1 = rA1 * rB3;
            rC2_0 += m2;
            m2 = rA2 * rB3;
            rC3_0 += m3;
            m3 = rA3 * rB3;
            rC0_1 += m4;
            m4 = rA0 * rB4;
            rC1_1 += m5;
            m5 = rA1 * rB4;
            rC2_1 += m6;
            m6 = rA2 * rB4;
            rC3_1 += m7;
            m7 = rA3 * rB4;
            rC0_2 += m8;
            m8 = rA0 * rB5;
            rC1_2 += m9;
            m9 = rA1 * rB5;
            rC2_2 += m10;
            m10 = rA2 * rB5;
            rC3_2 += m11;
            m11 = rA3 * rB5;
            rC0_3 += m0;
            rC1_3 += m1;
            rC2_3 += m2;
            rC3_3 += m3;
            rC0_4 += m4;
            rC1_4 += m5;
            rC2_4 += m6;
            rC3_4 += m7;
            rC0_5 += m8;
            rC1_5 += m9;
            rC2_5 += m10;
            rC3_5 += m11;
            pA0 += incAk0;
            pB0 += incBk0;
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0[4] = rC2_0;
            pC0[6] = rC3_0;
            *pC1 = rC0_1;
            pC1[2] = rC1_1;
            pC1[4] = rC2_1;
            pC1[6] = rC3_1;
            *pC2 = rC0_2;
            pC2[2] = rC1_2;
            pC2[4] = rC2_2;
            pC2[6] = rC3_2;
            *pC3 = rC0_3;
            pC3[2] = rC1_3;
            pC3[4] = rC2_3;
            pC3[6] = rC3_3;
            *pC4 = rC0_4;
            pC4[2] = rC1_4;
            pC4[4] = rC2_4;
            pC4[6] = rC3_4;
            *pC5 = rC0_5;
            pC5[2] = rC1_5;
            pC5[4] = rC2_5;
            pC5[6] = rC3_5;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_cJIK80x0x80TN4x1x12_a1_bX(80, k, 80, alpha, ca, lda, cb + (((Nb) << 6)+((Nb) << 4)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANN
#define ATL_cpNBmm_bX ATL_cgpNBmm_bX
#endif

void ATL_cJIK80x0x80TN80x80x0_a1_bX(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK80x0x80TN80x80x0_a1_bX(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK80x0x80TN80x80x0_a1_b1(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);

void ATL_cpNBmm_bX(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc)
{
   ATL_cJIK80x0x80TN80x80x0_a1_bX(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_cJIK80x0x80TN80x80x0_a1_bX(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_cJIK80x0x80TN80x80x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_cJIK80x0x80TN80x80x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
